package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PegawaiService;
import com.jasamedika.medifirst2000.service.RegistrasiPasienService;
import com.jasamedika.medifirst2000.service.ReservasiPasienService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.AgamaVO;
import com.jasamedika.medifirst2000.vo.AntrianPasienRegistrasiDetailVO;
import com.jasamedika.medifirst2000.vo.AntrianPasienRegistrasiVO;
import com.jasamedika.medifirst2000.vo.JenisKartuDetailVO;
import com.jasamedika.medifirst2000.vo.PasienVO;
import com.jasamedika.medifirst2000.vo.PegawaiVO;
import com.jasamedika.medifirst2000.vo.RegistrasiPasienVO;
import com.jasamedika.medifirst2000.vo.ReservasiPasienVO;

/**
 * Controller class for Registrasi Pasien Business
 * 
 * @author Askur
 */
@RestController
@RequestMapping("/reservasi-pasien")
public class ReservasiPasienController extends LocaleController<ReservasiPasienVO> implements
		IBaseRestController<ReservasiPasienVO> {

	@Autowired
	private ReservasiPasienService reservasiPasienService;
	
	@Autowired
	private PegawaiService pegawaiService;

	
	private static final Logger LOGGER = LoggerFactory
			.getLogger(ReservasiPasienController.class);	
	
//	@RequestMapping(value = "/get-pasien-baru", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
//	public ResponseEntity<ReservasiPasienVO> getPasienReservasi(String id) {
//		try {
//			ReservasiPasienVO result = reservasiPasienService.get(id);
//
//			if (null != result)
//				addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, "");
//			RestUtil.getJsonHttptatus(HttpStatus.CREATED);
//			return RestUtil.getJsonResponse(result, HttpStatus.CREATED);
//
//		} catch (ServiceVOException e) {
//			LOGGER.error("Got exception {} when add Pasien", e.getMessage());
//			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
//			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
//		} catch (JpaSystemException jse) {
//			LOGGER.error("Got exception {} when add Pasien", jse.getMessage());
//			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
//			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
//		}
//
//	}
	
	@RequestMapping(value = "/save-reservasi-pasien", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<ReservasiPasienVO> savePasien(@Valid @RequestBody ReservasiPasienVO vo) {
		try {
			ReservasiPasienVO result = reservasiPasienService.add(vo);

			if (null != result)
				addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, "");
			RestUtil.getJsonHttptatus(HttpStatus.CREATED);
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED);

		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add Pasien", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add Pasien", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}

	@RequestMapping(value = "/get-all-dokter", method = RequestMethod.GET)
	public ResponseEntity<List<PegawaiVO>> getAllDokter() {
		try {
			List<PegawaiVO> listPegawaiVo = pegawaiService.getAllDokter();
			return RestUtil.getJsonResponse(listPegawaiVo, HttpStatus.OK,mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when get all dokter", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when get all dokter", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}



	@Override
	public ResponseEntity<ReservasiPasienVO> getVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<String> addVO(ReservasiPasienVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> editVO(ReservasiPasienVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> deleteVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<List<ReservasiPasienVO>> getAllVO() {
		return null;
	}


	@Override
	public ResponseEntity<Collection<ReservasiPasienVO>> getAllVOWithQueryString(HttpServletRequest request,
			Integer page, Integer limit, String sort, String dir) {
		return null;
	}




}
